;ppmpx4b.asm version 3.5(for DPMI)
;	MACHINE LANGUAGE SUBROUTINES
;	for ppmpqs
;	1998-99 by YUJI KIDA
;
.386P

code	segment	use16
	assume	cs:code,ds:code

	INCLUDE	UBP.MAC
	include	ppmpx.h


writerowunitbyte	equ	0c000h
;
;writerowunitbyte must larger than each decomp data


	org	100h

start:
	jmp	start0

	include	dpmi4ub.h
	include	dpmi4ub.lib

start0:

; branch

	MOV_AX	AR0		;ARRAY[0] is the command
	MOV	BX,OFFSET CMD_TBL
	SHL	AX,1
	ADD	BX,AX
	JMP	CS:[BX]

CMD_TBL:
	dw	INITIALIZE,creatematrix,updatematrix,freememory

	even
spmem		dw	?
ssmem		dw	?

FBsize		dd	?	;size of original FactorBase
FBbytes		dd	?
MATsize		dd	?	;size of reduced matrix
MATbytes	dw	?,0	;byte size of row
MATdwords	dw	?,0	;dword size of row
ROWSsize	dd	?	;number of ROW data

fileptr		dd	?

histhandle	dw	?
RFBhandle	dw	?
ROWShandle	dw	?
decomphandle	dw	?

MAThandle	dw	?
MAThandle1	dw	?
MAThandle2	dw	?
MAThandle3	dw	?
MAThandle4	dw	?

Reptime		dw	?

	align	4
MAToffset	dd	?
MATsize1	dd	?
MATsize2	dd	?
MATsize3	dd	?
ROWSptr		dd	?
MATmemberID	dd	?

matrixbase	dd	?
databuffer	dd	?

RFBbase		dd	?
ROWSbase	dd	?
historybase	dd	?
totaloperations	dd	?

buffertop	dd	?
buffersize	dd	?
bufferover	dd	?

nextfileptr	dd	?

baseptr		dd	?
currentbaseptr	dd	?
nextbaseptr	dd	?
ptrsize		dd	?
ramsize		dd	?
currentbufferptr	dd	?
datacount	dd	?


;
; free DPMI memory
;
;command#=3

freememory:
	call	freemainDATAmemory
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


;
;* update matrix
;command#=2

updatematrix:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	call	getdecompdata
	call	writematrix

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


writematrix:
	mov	dx,offset MATRIXNAME1
	mov	ax,3d02h	;open for read/write
	int	21h
	jc	diskerror
	mov	[MAThandle1],ax

	mov	dx,offset MATRIXNAME2
	mov	ax,3d02h	;open for read/write
	int	21h
	jc	diskerror
	mov	[MAThandle2],ax

	mov	dx,offset MATRIXNAME3
	mov	ax,3d02h	;open for read/write
	int	21h
	jc	diskerror
	mov	[MAThandle3],ax

	mov	dx,offset MATRIXNAME4
	mov	ax,3d02h	;open for read/write
	int	21h
	jc	diskerror
	mov	[MAThandle4],ax

	call	real2protB

	mov	dx,ROWSblock
	mov	[Reptime],dx

	mov	eax,[MATsize]
	mov	ecx,[ROWSsize]
	cmp	eax,ecx
	jae	short wrtmat5
	mov	ecx,eax
wrtmat5:
	shr	ecx,ROWSblocklog
	xor	edx,edx		;MATmemberID counter
	mov	ebx,[ROWSbase]
wrtmat10:
	push	ebx
	push	ecx
	push	edx
	mov	[ROWSptr],ebx
	mov	[MATmemberID],edx
	xor	ebx,ebx
	mov	ax,[MAThandle1]
	cmp	edx,[MATsize1]
	jb	short wrtmat15
	mov	ebx,[MATsize1]
	mov	ax,[MAThandle2]
	cmp	edx,[MATsize2]
	jb	short wrtmat15
	mov	ebx,[MATsize2]
	mov	ax,[MAThandle3]
	cmp	edx,[MATsize3]
	jb	short wrtmat15
	mov	ebx,[MATsize3]
	mov	ax,[MAThandle4]
wrtmat15:
	mov	[MAThandle],ax
	mov	[MAToffset],ebx

	call	clear3rdbuffer
	call	backsubstitution
	call	clear2ndbuffer
	call	set2ndpart
	call	initfileptr
	call	write2ndpart
wrtmat20:
	pop	edx
	pop	ecx
	pop	ebx
	add	edx,ROWSblock		;32 rows
	add	ebx,4*ROWSblock
	dec	ecx
	jnz	wrtmat10

	call	wrtrests

	call	prot2real

	mov	ax,cs
	mov	ds,ax

	mov	bx,[MAThandle1]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle2]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle3]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle4]
	mov	ah,3eh			;close file
	int	21h
	ret


initfileptr:
	call	prot2real
	mov	eax,dword ptr [MATbytes]
	mov	ebx,[MATmemberID]
	sub	ebx,[MAToffset]
	mul	ebx
	mov	[fileptr],eax
	mov	bx,[MAThandle]
	mov	dx,word ptr [fileptr]
	mov	cx,word ptr [fileptr+2]
	mov	ax,4200h		;move file ptr
	int	21h
	call	real2protB
	ret


write2ndpart:
	mov	esi,[matrixbase]
	mov	cx,[Reptime]
write2ndlp:
	push	cx
	call	readoldsub
	call	make_xor
	call	writenewsub
	pop	cx
	dec	cx
	jnz	write2ndlp
	ret


readoldsub:
	push	esi
	call	prot2real

	mov	cx,[MATbytes]
	mov	dx,offset BUFFER
	mov	ah,3fh
	mov	bx,[MAThandle]
	int	21h

	mov	bx,[MAThandle]
	mov	dx,word ptr [fileptr]	;restore file ptr
	mov	cx,word ptr [fileptr+2]
	mov	ax,4200h		;move file ptr
	int	21h

	call	real2protB
	pop	esi
	ret

writenewsub:
	push	esi
	call	prot2real

	mov	cx,[MATbytes]
	mov	dx,offset BUFFER
	mov	bx,[MAThandle]
	mov	ah,40h			;write data
	int	21h
	jc	diskerror

	mov	eax,dword ptr [MATbytes]
	add	[fileptr],eax		;update fileptr

	call	real2protB
	pop	esi
	ret

make_xor:
	mov	cx,[MATdwords]
	mov	di,offset BUFFER
makexorlp:
	mov	eax,fs:[esi]
	add	esi,4
	xor	[di],eax
	add	di,4
	dec	cx
	jnz	makexorlp
	ret



;
;* create matrix
;command#=1

creatematrix:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	mov	[nextfileptr],0
	call	getdecompdata
	call	setmatrix
	retf

setmatrix:
	mov	dx,offset MATRIXNAME1
	mov	ah,3ch		;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[MAThandle1],ax

	mov	dx,offset MATRIXNAME2
	mov	ah,3ch		;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[MAThandle2],ax

	mov	dx,offset MATRIXNAME3
	mov	ah,3ch		;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[MAThandle3],ax

	mov	dx,offset MATRIXNAME4
	mov	ah,3ch		;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[MAThandle4],ax

	call	real2protB

	mov	dx,ROWSblock
	mov	[Reptime],dx

	mov	eax,[MATsize]
	mov	ecx,[ROWSsize]
	cmp	eax,ecx
	jae	short setmat5
	mov	ecx,eax
setmat5:
	shr	ecx,ROWSblocklog
	xor	edx,edx		;MATmemberID counter
	mov	ebx,[ROWSbase]
setmat10:
	push	ebx
	push	ecx
	push	edx
	mov	[ROWSptr],ebx
	mov	[MATmemberID],edx
	xor	ebx,ebx
	mov	ax,[MAThandle1]
	cmp	edx,[MATsize1]
	jb	short setmat12
	mov	ax,[MAThandle2]
	mov	ebx,[MATsize1]
	cmp	edx,[MATsize2]
	jb	short setmat12
	mov	ax,[MAThandle3]
	mov	ebx,[MATsize2]
	cmp	edx,[MATsize3]
	jb	short setmat12
	mov	ax,[MAThandle4]
	mov	ebx,[MATsize3]
setmat12:
	mov	[MAThandle],ax
	mov	[MAToffset],ebx

	call	clear3rdbuffer
	call	backsubstitution
	call	clear2ndbuffer
	call	set2ndpart
	call	writethisrow
setmat20:
	pop	edx
	pop	ecx
	pop	ebx
	add	edx,ROWSblock		;32 rows
	add	ebx,4*ROWSblock
	dec	ecx
	jnz	setmat10

	mov	eax,[ROWSsize]
	cmp	eax,[MATsize]
	jae	short setmat30

	call	setrests
	call	fillrests

setmat30:
	call	prot2real

	mov	ax,cs
	mov	ds,ax

	mov	bx,[MAThandle1]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle2]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle3]
	mov	ah,3eh			;close file
	int	21h
	mov	bx,[MAThandle4]
	mov	ah,3eh			;close file
	int	21h

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	ret


setrests:
	mov	eax,[ROWSsize]
	mov	ecx,eax
	shr	eax,ROWSblocklog
	shl	eax,ROWSblocklog
	sub	ecx,eax
	jbe	short setrestsret

	mov	[Reptime],cx
	mov	eax,ROWSblock
	add	[MATmemberID],eax
	shl	eax,2			;ROWSblock*4
	add	[ROWSptr],eax
	mov	ax,[MAThandle4]
	mov	ebx,[MATsize3]
	mov	[MAThandle],ax
	mov	[MAToffset],ebx
	call	clear3rdbuffer
	call	backsubstitution
	call	clear2ndbuffer
	call	set2ndpart
	call	writethisrow
setrestsret:
	ret

wrtrests:
	mov	eax,[ROWSsize]
	mov	ecx,eax
	shr	eax,ROWSblocklog
	shl	eax,ROWSblocklog
	sub	ecx,eax
	jbe	short wrtrestsret

	mov	[Reptime],cx
	mov	eax,ROWSblock
	add	[MATmemberID],eax
	shl	eax,2			;ROWSblock*4
	add	[ROWSptr],eax
	mov	ax,[MAThandle4]
	mov	ebx,[MATsize3]
	mov	[MAThandle],ax
	mov	[MAToffset],ebx
	call	clear3rdbuffer
	call	backsubstitution
	call	clear2ndbuffer
	call	set2ndpart
	call	initfileptr
	call	write2ndpart
wrtrestsret:
	ret


fillrests:
	mov	ecx,[MATsize]
	sub	ecx,[ROWSsize]
	mov	ax,[MAThandle4]
	mov	ebx,[MATsize3]
	mov	[MAThandle],ax
	mov	[MAToffset],ebx
fillrests10:
	push	ecx
	call	clear2ndbuffer
	mov	esi,[matrixbase]
	call	writerowsub
	pop	ecx
	dec	ecx
	jnz	fillrests10
fillrestsret:
	ret


backsubstitution:
	mov	ebx,[databuffer]
	mov	edi,[ROWSptr]	;initially set unit vector
	mov	dx,[Reptime]
backsubstlp1:
	mov	esi,fs:[edi]
	mov	al,1
	mov	cx,si
	shr	esi,3
	and	cl,7
	shl	al,cl
	xor	fs:[ebx+esi],al
	add	ebx,[FBbytes]
	add	edi,4
	dec	dx
	jnz	backsubstlp1
backsubstjp:
	mov	ebx,[databuffer]
	mov	edx,[totaloperations]
	or	edx,edx
	jz	backsubstret
	mov	esi,edx
	dec	esi
	shl	esi,3		;8 = operation unit size
	add	esi,[historybase]	;final operation ptr

backsubst10:
	push	esi			;/!
	mov	edi,fs:[esi]		;dest
	mov	ax,0101h
	mov	cx,di
	shr	edi,3
	and	cl,7
	shl	al,cl

	mov	esi,fs:[esi+4]		;source
	mov	cx,si
	shr	esi,3
	and	cl,7
	shl	ah,cl

	mov	cx,[Reptime]
backsubstlp2:
	test	fs:[ebx+edi],al
	jz	short backsubst20
	xor	fs:[ebx+esi],ah
backsubst20:
	add	ebx,[FBbytes]
	dec	cx
	jnz	backsubstlp2

	pop	esi			;!/
	mov	ebx,[databuffer]
	sub	esi,8
	dec	edx
	jnz	backsubst10
backsubstret:
	ret


set2ndpart:
	mov	ebx,[baseptr]
	mov	esi,[databuffer]
	mov	ecx,[FBsize]
	shr	ecx,4		;16bit each
set2nd10:
	push	ecx		;/*
	mov	[currentbufferptr],esi
	mov	dx,1
	mov	cx,16		;16bit each
set2nd20:
	cmp	ebx,[currentbaseptr]
	jb	set2nd30
	cmp	ebx,[nextbaseptr]
	jae	set2ndret

	push	cx		;/#
	mov	ebp,[matrixbase]
	mov	cx,[Reptime]
set2ndlp1:
	test	fs:[esi],dx
	jnz	short set2ndsub
set2ndjp:
	add	esi,[FBbytes]
	add	ebp,dword ptr [MATbytes]
	dec	cx
	jnz	set2ndlp1
	mov	esi,[currentbufferptr]
	pop	cx		;#/
set2nd30:
	shl	dx,1
	add	ebx,4
	dec	cx
	jnz	set2nd20

	pop	ecx		;*/
	add	esi,2
	dec	ecx
	jnz	set2nd10
	ret
set2ndret:
	pop	eax		;*/dummy
	ret


set2ndsub:
	push	cx
	push	ebx
	mov	ebx,fs:[ebx]	;top of the decomposition data
	mov	cx,fs:[ebx]
	jcxz	set2ndsubret
set2ndsub10:
	add	ebx,4
	mov	eax,fs:[ebx]
	push	cx		;/$
	mov	cl,al
	and	cl,7
	shr	eax,3
	add	eax,ebp
	mov	edi,eax
	mov	al,1
	shl	al,cl
	xor	fs:[edi],al
	pop	cx		;$/
set2ndsub20:
	dec	cx
	jnz	set2ndsub10
set2ndsubret:
	pop	ebx
	pop	cx
	jmp	set2ndjp


clear2ndbuffer:
	mov	edi,[matrixbase]
clearbuffer10:
	mov	ecx,[MATsize]
clearbuffer20:
	shr	ecx,5			;1/32
	shl	ecx,ROWSblocklog	;*32
	xor	eax,eax
clearbuffer30:
	mov	fs:[edi],eax
	add	edi,4
	dec	ecx
	jnz	clearbuffer30
	ret


clear3rdbuffer:
	mov	edi,[databuffer]
	mov	ecx,[FBsize]
	jmp	clearbuffer20

writethisrow:
	mov	esi,[matrixbase]
	mov	cx,[Reptime]
writethisrowlp:
	push	cx
	push	esi
	call	writerowsub
	pop	esi
	pop	cx
	add	esi,dword ptr [MATbytes]
	dec	cx
	jnz	writethisrowlp
	ret

writerowsub:
	mov	di,offset BUFFER
	mov	cx,[MATdwords]
writerowsublp:
	mov	eax,fs:[esi]
	add	esi,4
	mov	[di],eax
	add	di,4
	dec	cx
	jnz	writerowsublp

	call	prot2real

	mov	cx,[MATbytes]
	mov	bx,[MAThandle]
	mov	dx,offset BUFFER
	mov	ah,40h			;write data
	int	21h
	jc	diskerror

	call	real2protB
	ret


getdecompdata:
	mov	dx,offset decomp2
	mov	ax,3d00h	;open for read
	int	21h
	jc	diskerror
	mov	[decomphandle],ax

	mov	bx,ax
	mov	eax,[nextfileptr]
	shl	eax,2
	push	eax
	pop	dx
	pop	cx
	mov	ax,4200h		;move file ptr
	int	21h

	call	real2protB

	mov	edi,[buffertop]
	mov	ebx,[nextbaseptr]
	mov	[datacount],0
	mov	[currentbaseptr],ebx
getdecomp10:
	push	ebx
	push	edi

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,4			;read header
	mov	bx,[decomphandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	getdecompeof

	mov	cx,word ptr [BUFFER]
	mov	dx,offset BUFFER+4
	shl	cx,2			;4byte/data
	mov	bx,[decomphandle]
	mov	ah,3fh
	int	21h

	push	ax
	call	real2protB
	pop	cx

	pop	edi
	pop	ebx
	mov	fs:[ebx],edi
	add	ebx,4
	mov	si,offset BUFFER


	mov	eax,[si]
	add	si,4
	mov	fs:[edi],eax
	mov	cx,ax
	inc	eax
	add	edi,4
	add	[datacount],eax
	or	cx,cx
	jz	short getdecomp30

	xor	dx,dx			;;counter
	push	edi			;/*
getdecomp20:
	mov	eax,[si]
	add	si,4
	shl	eax,2
	add	eax,[RFBbase]
	mov	eax,fs:[eax]
	inc	eax
	jz	short getdecompjp	;if non used data
	dec	eax
	mov	fs:[edi],eax
	add	edi,4
	inc	dx
getdecompjp:
	dec	cx
	jnz	getdecomp20
	pop	esi			;*/
	mov	fs:[esi-4],dx		;set new # of elements

getdecomp30:
	cmp	edi,[bufferover]
	jb	getdecomp10
	push	ebx
	push	edi
	call	prot2real

getdecompeof:
	pop	edi
	pop	ebx

getdecompout:
	mov	eax,[datacount]
;	shl	eax,2
	add	eax,[nextfileptr]
	mov	[nextfileptr],eax
	mov	[nextbaseptr],ebx

	mov	ah,3eh		;close file
	mov	bx,[decomphandle]
	int	21h
	ret


;
;* Initialize
;
;COMMAND#=0

;	A1 = members

INITIALIZE:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax

	mov	[spmem],sp

	xor	eax,eax
	mov_ax	AR1
	shl	eax,10
	mov	edx,eax
	xor	eax,eax
	mov_ax	AR2
	add	eax,edx
	mov	[FBsize],eax
	shr	eax,3
	mov	[FBbytes],eax

	xor	eax,eax
	mov_ax	AR5
	shl	eax,20		;mega byte
	mov	[ramsize],eax

	xor	eax,eax
	mov_ax	AR3
	shl	eax,10
	mov	edx,eax
	xor	eax,eax
	mov_ax	AR4
	add	eax,edx
	mov	[MATsize],eax
	shr	eax,3
	mov	[MATbytes],ax
	shr	eax,2
	mov	[MATdwords],ax
	shl	eax,2
	shl	eax,ROWSblocklog	;*32
	mov	[matrixbase],0
	mov	[databuffer],eax
	mov	edx,[FBbytes]
	shl	edx,ROWSblocklog	;*32
	add	eax,edx
	mov	[RFBbase],eax
	push	eax
	call	totalfilesize
	pop	edx
	add	eax,edx
	push	eax
	call	getptrsize
	pop	edx
	add	eax,edx
	push	eax
	call	getdecompbuffersize	;use eax
	pop	edx
	or	eax,eax
	jz	dpmierror		;lack of memory

	add	eax,edx
	add	eax,0fh		;for alignment safety *
	mov	[DPMImemorysize],eax

	call	DPMIinit
	jc	dpmierror

	mov	eax,dword ptr [DPMIaddresslow]
	add	eax,0fh		;
	and	ax,0fff0h	;* see above

	add	[matrixbase],eax
	add	[databuffer],eax
	add	[RFBbase],eax

	call	prot2real
	call	getRFB
	call	getROWS
	call	gethistDATA

	mov	ax,cs
	mov	ds,ax

	;init decomp buffer

	mov	eax,[baseptr]
	mov	[nextbaseptr],eax
	add	eax,[ptrsize]
	mov	[buffertop],eax
	add	eax,[buffersize]
	mov	[bufferover],eax

	mov	eax,[MATsize]
	shr	eax,2		;1/4
	shr	eax,ROWSblocklog
	shl	eax,ROWSblocklog	;multiple of 32
	mov	[MATsize1],eax
	mov	edx,eax
	add	eax,edx
	mov	[MATsize2],eax
	add	eax,edx
	mov	[MATsize3],eax

	mov	ax,word ptr [dpmimemorysize+2]
	mov	bx,AR0
	mov	[bx],ax
initout:
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

diskerror:
	mov	ax,8001h
errorout:
	mov	bx,cs
	mov	ds,bx

	mov	bx,AR0
	mov	[bx],ax
	mov	sp,[spmem]
	jmp	initout

initlackofdata:
	mov	ax,8002h
	jmp	errorout
dpmierror:
;	call	prot2real
	mov	ax,8003h
	jmp	errorout


	; copy RFB file to memory

getRFB:
	mov	ax,3d00h		;open for read
	mov	dx,offset RFBfilename
	int	21h
	jc	diskerror
	mov	[RFBhandle],ax

	call	real2protB

	mov	edi,[RFBbase]
getRFB10:
	push	edi

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[RFBhandle]
	mov	ah,3fh		;read
	int	21h
	or	ax,ax
	jz	short getRFBeof

	push	ax
	call	real2protB
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
	pop	edi
getRFB20:
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	loop	getRFB20
	jmp	getRFB10

getRFBeof:
	pop	eax
	mov	[ROWSbase],eax

	mov	ah,3eh		;close file
	mov	bx,[RFBhandle]
	int	21h
	ret


getROWS:
	mov	ax,3d00h		;open for read
	mov	dx,offset ROWSfilename
	int	21h
	jc	diskerror
	mov	[ROWShandle],ax

	call	real2protB

	mov	edi,[ROWSbase]
getROWS10:
	push	edi

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[ROWShandle]
	mov	ah,3fh		;read
	int	21h
	or	ax,ax
	jz	short getROWSeof

	push	ax
	call	real2protB
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
	pop	edi
getROWS20:
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	loop	getROWS20
	jmp	getROWS10

getROWSeof:
	pop	eax
	mov	[historybase],eax
	sub	eax,[ROWSbase]
	shr	eax,2
	mov	[ROWSsize],eax

	mov	ah,3eh		;close file
	mov	bx,[ROWShandle]
	int	21h
	ret


gethistDATA:
	mov	ax,3d00h	;open for read
	mov	dx,offset HISTORYFILENAME
	int	21h
	jc	diskerror
	mov	[histhandle],ax

	call	real2protB

	mov	edi,[historybase]
gethist10:
	push	edi

	call	prot2real

	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[histhandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	short gethisteof

	push	ax
	call	real2protB
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
	pop	edi
gethist20:
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	loop	gethist20
	jmp	gethist10

gethisteof:
	pop	eax
	mov	[baseptr],eax
	sub	eax,[historybase]
	shr	eax,3			;8bytes/unit
	mov	[totaloperations],eax

	mov	ah,3eh			;close file
	mov	bx,[histhandle]
	int	21h
	ret


getptrsize:
	mov	dx,offset DECOMP2
	mov	ax,3d00h	;read open
	int	21h
	mov	bx,ax
	call	getptrsizesub
	mov	[ptrsize],esi
	ret

getptrsizesub:
	xor	esi,esi
getptrsize10:
	mov	ah,3fh		;read file
	mov	cx,4
	mov	dx,offset BUFFER
	int	21h
	or	ax,ax
	jz	getptrsize20	;eof

	mov	edx,dword ptr [BUFFER]	;# of members
	shl	edx,2		;*4
	add	esi,4

	push	edx
	pop	dx
	pop	cx
	mov	ax,4201h		;move file ptr
	int	21h
	jmp	getptrsize10

getptrsize20:
	mov	ah,3eh			;close file
	int	21h
	ret


totalfilesize:
	xor	esi,esi
	mov	dx,offset RFBFILENAME
	call	getfilesize
	add	esi,eax
	mov	dx,offset ROWSFILENAME
	call	getfilesize
	add	esi,eax
	mov	dx,offset HISTORYFILENAME
	call	getfilesize
	add	eax,esi			;eax = result
	ret


getfilesize:
	;inp dx = offset of file name
	;out eax = size

	mov	ax,3d00h		;read open
	int	21h

	push	ax			;handle
	mov	bx,ax
	mov	ax,4202h		;move file ptr to end
	xor	cx,cx
	xor	dx,dx
	int	21h
					;now dx:ax = file size
	pop	bx
	push	dx
	push	ax

	mov	ah,3eh			;close file
	int	21h

	pop	eax
	ret


getdecompbuffersize:
	mov	ecx,[ramsize]
	sub	ecx,1000h
	sub	ecx,eax			;eax = RAM already used
	jbe	getbufsizeerror
	mov	[buffersize],ecx

	mov	dx,offset DECOMP2
	call	getfilesize
	cmp	eax,[buffersize]
	ja	short getbufsizeerror
getbufsize20:
	mov	[buffersize],eax
	add	eax,1000h		;for over run
	ret

getbufsizeerror:
	xor	eax,eax
	ret


HISTORYFILENAME	db	'ppmphist.ppm',0
RFBFILENAME	db	'ppmprfb.ppm',0
ROWSFILENAME	db	'ppmprows.ppm',0
DECOMP2		db	'ppmpdcp2.ppm',0
MATRIXNAME1	db	'ppmpmat1.ppm',0
MATRIXNAME2	db	'ppmpmat2.ppm',0
MATRIXNAME3	db	'ppmpmat3.ppm',0
MATRIXNAME4	db	'ppmpmat4.ppm',0


	align	4
BUFFER		db	writerowunitbyte dup(0)

CODE	ENDS
END	START
