;ppmpx5b.asm version 3.5(for DPMI)
;	MACHINE LANGUAGE SUBROUTINES
;	FOR ppmpqs
;	1998-99 by YUJI KIDA
;
.386p

code	segment	use16
	assume	cs:code,ds:code


	INCLUDE	UBP.MAC
	include	ppmpx.h


	org	100h
start:
	JMP	start0

	include	dpmi4ub.h
	include	dpmi4ub.lib


	 align	4
ROWSbase	dd	?
historybase	dd	?

totaloperations	dd	?

totalFBsize	dd	?
Rmatrixsize	dd	?

ROWShandle	dw	?
anshandle	dw	?
ans1handle	dw	?
histhandle	dw	?

databufferbase	dd	?
databuffer	dd	?
weightbuffer	dd	?
weightbufferover	dd	?

Rbytes		dw	?
Rwords		dw	?

Tbytes		dd	?
Twords		dd	?
Tdwords		dd	?

writedwordsnow	dd	?

spmem		dw	?


;branch

START0:
	MOV_AX	AR0		;ARRAY[0] is the command number
	MOV	BX,OFFSET CMD_TBL
	SHL	AX,1
	ADD	BX,AX
	JMP	CS:[BX]

CMD_TBL:
	dw	finalinit,convert_ansfile,closefiles

;
; close files and free DPMI memory
;
;command#=2

closefiles:
	mov	ah,3eh
	mov	bx,cs:[anshandle]
	or	bx,bx
	jz	short closef10
	int	21h
closef10:
	mov	ah,3eh
	mov	bx,cs:[ans1handle]
	or	bx,bx
	jz	short closefret
	int	21h
closefret:
	call	freemainDATAmemory
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf


;
; answer square data
;
;command#=1

ANSmax	equ	256	;max of answer

convert_ansfile:
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	mov	[spmem],sp

	mov	eax,[databufferbase]
	mov	[databuffer],eax
	mov	ecx,ANSmax
convertlp:
	push	ecx
	mov	dx,offset BUFFER	;read answer
	mov	cx,[Rbytes]	;Rbytes must < 62K
	mov	bx,[anshandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	nomoreanswer

	call	real2protB
	call	translate
	call	backsubstitution
	call	prot2real
	mov	eax,[databuffer]
	add	eax,[Tbytes]
	mov	[databuffer],eax
	pop	ecx
	dec	ecx
	jnz	convertlp
convertret:
	call	real2protB
	call	countweights
	call	sortresults
	call	writeresults
	call	prot2real

	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

nomoreanswer:
	pop	ecx		;dummy
	mov	bx,AR0
	mov	word ptr [bx],0
	jmp	convertret


weightbytes	equ	8	;= bytes of weightdata


countweights:
	mov	esi,[databufferbase]
	mov	ebx,[weightbuffer]
	xor	eax,eax
	mov	fs:[ebx],eax	;weight 0 = sentinel
	mov	fs:[ebx+4],eax	;data number
	add	ebx,weightbytes	;1st is dummy
ctwlp1:
	cmp	esi,[databuffer]
	jae	ctwret

	mov	ecx,[Tdwords]
	xor	edx,edx		;counter
	shr	ecx,1		;first half
ctwlp2:
	mov	eax,fs:[esi]
	add	esi,4
ctwlp3:
	shr	eax,1
	adc	edx,0
	or	eax,eax
	jnz	ctwlp3
	dec	ecx
	jnz	ctwlp2
	mov	fs:[ebx],edx	;set weight of half

	mov	ecx,[Tdwords]
	xor	edx,edx
	shr	ecx,2		;3rd quater
ctwlp2b:
	mov	eax,fs:[esi]
	add	esi,4
ctwlp3b:
	shr	eax,1
	adc	edx,0
	or	eax,eax
	jnz	ctwlp3b
	dec	ecx
	jnz	ctwlp2b
	add	edx,edx		;weight 2 for 3rd quater
	add	fs:[ebx],edx	;add weight

	xor	edx,edx
	mov	eax,[Tdwords]
	mov	ecx,eax
	shr	eax,1
	sub	ecx,eax
	shr	eax,1
	sub	ecx,eax		;last quater
ctwlp2c:
	mov	eax,fs:[esi]
	add	esi,4
ctwlp3c:
	shr	eax,1
	adc	edx,0
	or	eax,eax
	jnz	ctwlp3c
	dec	ecx
	jnz	ctwlp2c
	shl	edx,2		;weight 4 for last quater
	add	fs:[ebx],edx	;add weight of last half

	mov	eax,fs:[ebx+4-weightbytes]	;last data #
	inc	eax
	mov	fs:[ebx+4],eax
	add	ebx,weightbytes
	jmp	ctwlp1
ctwret:
	mov	[weightbufferover],ebx
	ret


sortresults:
	mov	ebx,[weightbuffer]
	add	ebx,weightbytes
sortreslp:
	add	ebx,weightbytes
	cmp	ebx,[weightbufferover]
	jae	short sortresret
	mov	eax,fs:[ebx]
	cmp	eax,fs:[ebx-weightbytes]
	jae	sortreslp
	lea	esi,[ebx-weightbytes]
	mov	edi,fs:[ebx+4]		;*memo
sortreslp2:
	mov	ecx,fs:[esi]
	mov	edx,fs:[esi+4]
	mov	fs:[esi+weightbytes],ecx
	mov	fs:[esi+weightbytes+4],edx
	sub	esi,weightbytes
	cmp	eax,fs:[esi]
	jb	sortreslp2
	add	esi,weightbytes
	mov	fs:[esi],eax
	mov	fs:[esi+4],edi		;memo*
	jmp	sortreslp
sortresret:
	ret


writeunitdwords	equ	2000		;8Kbytes

writeresults:
	mov	ebx,[weightbuffer]
wrtreslp:
	add	ebx,weightbytes
	cmp	ebx,[weightbufferover]
	jae	short wrtresret
	push	ebx			;/*

	mov	eax,fs:[ebx+4]
	dec	eax
	mul	[Tbytes]
	add	eax,[databufferbase]
	mov	esi,eax			;starts here
	mov	ecx,[Tdwords]		;toral dwords
wrtreslp2:
	push	ecx			;/**
	mov	edi,offset BUFFER	;destination
	cmp	ecx,writeunitdwords
	jbe	short wrtres10
	mov	ecx,writeunitdwords
wrtres10:
	mov	[writedwordsnow],ecx
movreslp:
	mov	eax,fs:[esi]
	add	esi,4
	mov	[edi],eax
	add	edi,4
	dec	ecx
	jnz	movreslp

	push	esi			;/***
	call	prot2real
	mov	ah,40h
	mov	bx,[ans1handle]
	mov	cx,word ptr [writedwordsnow]
	mov	dx,offset BUFFER
	shl	cx,2		;convert to byte
	int	21h
	jc	diskerror
	call	real2protB
	pop	esi			;***/

	pop	ecx			;**/
	sub	ecx,[writedwordsnow]
	ja	wrtreslp2	;still remain

	pop	ebx		;*/
	jmp	wrtreslp
wrtresret:
	ret


;
; convert reduced vector relation
; to full vector relation
;
translate:
	mov	edi,[databuffer]
	mov	ecx,[Tdwords]
	xor	eax,eax
trans5:
	mov	fs:[edi],eax
	add	edi,4
	dec	ecx
	jnz	trans5

	mov	ebx,[ROWSbase]
	mov	si,offset BUFFER
	mov	cx,[Rwords]
trans10:
	push	cx
	lodsw
	mov	cx,16
trans20:
	shr	ax,1
	jnc	short trans30

	push	cx
	push	ax

	mov	edi,fs:[ebx]
	mov	cx,di
	and	cl,7
	shr	edi,3
	mov	al,1
	shl	al,cl
	add	edi,[databuffer]
	or	fs:[edi],al

	pop	ax
	pop	cx

trans30:
	add	ebx,4
	dec	cx
	jnz	trans20

	pop	cx
	dec	cx
	jnz	trans10
	ret


backsubstitution:
	mov	ebx,[databuffer]
	mov	edx,[totaloperations]
	mov	esi,edx
	dec	esi
	shl	esi,3			;*8
	add	esi,[historybase]
  align	4
backsubst10:
	mov	edi,fs:[esi]		;dest
	mov	cx,di
	and	cl,7
	shr	edi,3
	mov	al,1
	shl	al,cl
	test	fs:[edi+ebx],al
	jnz	short backsubst30
backsubst20:
	sub	esi,8
	dec	edx
	jnz	backsubst10
	ret

  align	4
backsubst30:
	mov	edi,fs:[esi+4]		;source
	mov	cx,di
	and	cl,7
	shr	edi,3
	mov	al,1
	shl	al,cl
	xor	fs:[edi+ebx],al
	jmp	backsubst20

;
;* Initialize
;
;COMMAND#=0
;

seg2linear:
	movzx	eax,word ptr [bx+2]
	movzx	edx,word ptr [bx]
	shl	eax,4
	add	eax,edx
	ret

	
finalinit:
	;get parameters

	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	push	bp
	mov	[spmem],sp

	xor	eax,eax
	mov_ax	AR1
	shl	eax,10
	mov	edx,eax
	xor	eax,eax
	mov_ax	AR2
	add	eax,edx
	mov	[totalFBsize],eax

	shr	eax,3		;/ 8
	mov	[Tbytes],eax
	shr	eax,1
	mov	[Twords],eax
	shr	eax,1
	mov	[Tdwords],eax

	;get DPMI memory

	call	totalfilesize
	mov	ecx,eax
	mov	eax,[Tbytes]	;unit size of converted data
	add	eax,weightbytes	;unit size of weight
	mov	edx,ansMAX
	inc	edx
	mul	edx
	add	eax,ecx
	add	eax,0fh		;for alignment safety *
	mov	[DPMImemorysize],eax

	call	DPMIinit
	jc	dpmierror

	mov	eax,dword ptr [DPMIaddresslow]
	add	eax,0fh		;
	and	al,0f0h		;*
	mov	[ROWSbase],eax

	call	prot2real
	call	getROWS
	call	gethistDATA
	call	openANSFILE
	call	createans1file

initout:
	pop	bp
	mov	ax,ss
	mov	ds,ax
	mov	es,ax
	retf

diskerror:
	mov	ax,8001h
initerror:
	mov	ds:[AR0],ax
	mov	sp,[spmem]
	jmp	initout

dpmierror:
;	call	prot2real
	mov	ax,8002h
	jmp	initerror


createans1file:
	mov	dx,offset ANS1FILENAME	;create ANS1 file
	mov	ah,3ch			;create handle
	mov	cx,0
	int	21h
	jc	diskerror
	mov	[ans1handle],ax
	ret

openANSFILE:
	mov	dx,offset ansfilename	;read matrix size
	mov	ax,3d00h		;from answer file
	int	21h
	jc	diskerror
	mov	[anshandle],ax

	mov	dx,offset Rmatrixsize	;get matrixsize
	mov	cx,4
	mov	bx,ax
	mov	ah,3fh			;read
	int	21h
	jc	diskerror

	mov	eax,[Rmatrixsize]
	shr	eax,3
	mov	[Rbytes],ax	;must be 16bit
				;Rmatrixsize < 8*2^16=512K
	shr	ax,1
	mov	[Rwords],ax
	ret


gethistDATA:
	mov	ax,3d00h		;open for read
	mov	dx,offset historyfilename
	int	21h
	jc	diskerror
	mov	[histhandle],ax

	mov	edi,[historybase]
gethist10:
	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[histhandle]
	mov	ah,3fh
	int	21h
	or	ax,ax
	jz	short gethisteof

	push	ax
	push	edi
	call	real2protB
	pop	edi
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
gethist20:
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	dec	cx
	jnz	gethist20

	push	edi
	call	prot2real
	pop	edi
	jmp	gethist10

gethisteof:
	mov	[weightbuffer],edi
	mov	eax,ANSmax
	inc	eax			;one more
	mov	ecx,weightbytes
	mul	ecx
	add	eax,edi
	mov	[databufferbase],eax
	sub	edi,[historybase]
	shr	edi,3			;8bytes/unit
	mov	[totaloperations],edi

	mov	ah,3eh			;close file
	mov	bx,[histhandle]
	int	21h
	ret


getROWS:
	mov	ax,3d00h		;open for read
	mov	dx,offset ROWSfilename
	int	21h
	jc	diskerror
	mov	[ROWShandle],ax

	mov	edi,[ROWSbase]
getROWS10:
	mov	dx,offset BUFFER
	mov	cx,1000h
	mov	bx,[ROWShandle]
	mov	ah,3fh			;read
	int	21h
	or	ax,ax
	jz	short getROWSeof

	push	ax
	push	edi
	call	real2protB
	pop	edi
	pop	cx

	shr	cx,2
	mov	si,offset BUFFER
getROWS20:
	lodsd
	mov	fs:[edi],eax
	add	edi,4
	loop	getROWS20

	push	edi
	call	prot2real
	pop	edi
	jmp	getROWS10

getROWSeof:
	mov	[historybase],edi

	mov	ah,3eh			;close file
	mov	bx,[ROWShandle]
	int	21h
	ret


totalfilesize:
	xor	esi,esi
	mov	dx,offset ROWSFILENAME
	call	getfilesize
	add	esi,eax
	mov	dx,offset historyfilename
	call	getfilesize
	add	eax,esi			;eax = result
	ret


getfilesize:
	;inp dx = offset of file name
	;out eax = size

	mov	ax,3d00h		;read open
	int	21h

	push	ax			;handle
	mov	bx,ax
	mov	ax,4202h		;move file ptr to end
	xor	cx,cx
	xor	dx,dx
	int	21h
					;now dx:ax = file size
	pop	bx
	push	dx
	push	ax

	mov	ah,3eh			;close file
	int	21h

	pop	eax
	ret


ansfilename	db	'ppmpans.ppm',0
ans1filename	db	'ppmpans1.ppm',0
historyfilename	db	'ppmphist.ppm',0
ROWSFILENAME	db	'ppmprows.ppm',0


	align	4
BUFFER	dw	?

CODE	ENDS
END	START
